use crate::{
    app::session::SessionToken,
    util::pack::pack_u16,
};

use super::Packet;

#[derive(Clone)]
pub struct PacketSessionCreate {

}
impl PacketSessionCreate {
    pub fn new() -> Self
    {
        Self { }
    }
}
impl Packet for PacketSessionCreate {
    type Data = Self;

    fn decode(_data:&Vec<u8>, _index:&mut usize) -> Result<Self::Data, ()>
    {
        Ok(Self::new())
    }
}


#[derive(Clone)]
pub struct PacketSessionCreateResponse {
    pub status:u16,
    pub token:SessionToken,
}
impl PacketSessionCreateResponse {
    pub fn new() -> Self
    {
        Self {
            status:0,
            token:SessionToken::default(),
        }
    }
}
impl Packet for PacketSessionCreateResponse {
    type Data = Self;

    fn encode(&self) -> Vec<u8>
    {
        [
            pack_u16(self.status),
            self.token.to_vec(),
        ].concat()
    }
}
